<?php
/*
OneSQLiteAdmin

Copyright (c) 2010 Mitsugi Tsutsumi

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

//config - Auth
$config["user"]="admin";
$config["password"]="pass";

//config - db file
$config["db"][]="db_admin.db";
$config["db"][]="test/test.db";


//リセットスタイル
if(@$_GET["s"]=="resetcss"){
	header('Content-type: text/css; charset=utf-8');
	print(getericcss());
	exit;

//CSS
}else if(@$_GET["s"]=="css"){
	header('Content-type: text/css; charset=utf-8');
	print(getcss());
	exit;

//js
}else if(@$_GET["s"]=="js"){
	header('Content-type: text/javascript; charset=utf-8');
	print(getjs());
	exit;

//jkl-parsexml.js
}else if(@$_GET["s"]=="jkl-parsexmlJs"){
	header('Content-type: text/javascript; charset=utf-8');
	print(getjkl_parsexml_js());
	exit;
}


//認証
session_start();
if (isset($_POST["onedbadmin_username"])) { $_SESSION['onedbadmin_username'] = $_POST["onedbadmin_username"]; }
if (isset($_POST["onedbadmin_password"])) { $_SESSION['onedbadmin_password'] = $_POST["onedbadmin_password"]; }
if ((@$_POST['onedbadmin_username'] == $config["user"]) and (@$_POST['onedbadmin_password'] == $config["password"])) {
	header("Location: ".$_SERVER["SCRIPT_NAME"]);
}
if ((@$_SESSION['onedbadmin_username'] == $config["user"]) and (@$_SESSION['onedbadmin_password'] == $config["password"])) {
	$_SESSION['onedbadmin_valid'] = "1";
} else {
	$_SESSION['onedbadmin_valid'] = "0";
	if ($_GET["s"] !== "login") { header("Location: ".$_SERVER["SCRIPT_NAME"]."?s=login"); }
}
if(@$_GET["s"] == "logout") {
	@$_SESSION['onedbadmin_valid'] = "0"; session_destroy();
	echo buildHtml(getLogoutP(),"logout");
}


//sが設定されていない場合
if(!isset($_GET["s"])){
	echo buildHtml(<<<EOF
<frameset cols="20%,*"><frame name="menu" src="?s=menu"><frame name="body" src="?s=index"></frameset>
EOF
,"top");
	exit;

//ログインページ表示
}else if($_GET["s"] == "login"){
	echo buildHtml(getLoginP(),"login");


//index表示
}else if($_GET["s"] == "index"){
	$me = $_SERVER["SCRIPT_NAME"];
	$PHPversion = phpversion();
	$SQLiteVersions = "non";

	//PDOが存在かつsqliteのドライバがある場合
	if(class_exists('PDO') && in_array('sqlite', PDO::getavailabledrivers())) {
		//メモリ内にデータベースを作成し、SQLiteのバージョンを取得
		$memoryDB = new PDO('sqlite::memory:', '', '');
		$query = "SELECT sqlite_version();";
		$result = $memoryDB->query($query);
		$SQLiteVersion = $result->fetchColumn();
		unset($memoryDB, $result,$query);
	}

	$head = <<<EOF
<script type="text/javascript"><!--
window.onload = function (){
	var divObj = document.getElementById("dblist");
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=dblist");
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
}
// --></script>
EOF;

	$body = <<<EOF
<div>OneSQLiteAdmin</div>
<hr/>
<div>PHP version {$PHPversion}</div>
<div>SQLite version {$SQLiteVersion}</div>
<hr/>
<div id="dblist"></div>
EOF;
	echo buildHtml_s($body,"index",$head);
	exit;

//menu表示
}else if($_GET["s"] == "menu"){
	$me = $_SERVER["SCRIPT_NAME"];
	$body = <<<EOF
<div><a href="${me}" target="_top">TOP</a>|<a href="?s=logout" target="_top">logout</a></div>
<hr/>
<div id="dblist"></div>
EOF;
	$head = <<<EOF
<script type="text/javascript"><!--
window.onload = function (){
	var divObj = document.getElementById("dblist");
	var httpObj = new JKL.ParseXML.JSON("${me}?s=json&p=dblist");
	var data = httpObj.parse();
	if(data.length>0){
		var db_ul=document.createElement("ul");
		db_ul.className="dbs";
		for (var key in data) {
			var db_li=document.createElement("li");
			db_li.className="db";

			var db_anchor=document.createElement("a");
			db_anchor.href="?s=tbls&dbid="+key;
			db_anchor.target="body"
			var text = document.createTextNode(data[key]["db"]);
			db_anchor.appendChild(text);
			db_li.appendChild(db_anchor);


			if(data[key]["tables"].length>0){
				var tbl_ul=document.createElement("ul");
				tbl_ul.className="tbls";
				for (var tkey in data[key]["tables"]) {
					var tbl_li=document.createElement("li");
					tbl_li.className="tbl";

					var tbl_anchor=document.createElement("a");
					tbl_anchor.href="?s=tbl&dbid="+key+"&tblname="+data[key]["tables"][tkey]["name"];
					tbl_anchor.target="body"
					var text = document.createTextNode(data[key]["tables"][tkey]["name"]);
					tbl_anchor.appendChild(text);
					tbl_li.appendChild(tbl_anchor);
					tbl_ul.appendChild(tbl_li);
				}
				tbl_ul.appendChild(tbl_li);
				db_li.appendChild(tbl_ul);
			}

			db_ul.appendChild(db_li);
		}
		divObj.appendChild(db_ul);
	}
}
// --></script>
EOF;
	echo buildHtml_s($body,"menu",$head);
exit;


//jsonの場合
}else if(@$_GET["s"]=="json"){

	//dblistを取得の場合
	if(@$_GET["p"]=="dblist"){
		echo json_encode(getdbdata($config["db"]));
		exit;
	}

//htmlの場合
}else if(@$_GET["s"]=="html"){

	//dblistを取得の場合
	if(@$_GET["p"]=="dblist"){
		$dbdata = getdbdata($config["db"]);
		$body = '<ul class="dbs">';
		foreach($dbdata as $key => $value){
			$db = $value["db"];
			$body .= '<li class="db"><a href="?s=tbls&dbid='.$key.'" target="body">'.$db.'</a></li>';
		}
		$body .= '</li></ul>';
		echo $body;
		exit;

	//tablelistを取得の場合
	}elseif(@$_GET["p"]=="tbllist"){
		$dbid = @$_GET["dbid"];
		$tbl_dbh = new PDO('sqlite:'.$config["db"][$dbid],'', '');
		$table_names = $tbl_dbh->prepare("select name from sqlite_master where type='table' order by name");
		$table_names->execute();
		$table_names = $table_names->fetchAll(PDO::FETCH_ASSOC);

		$body = '<ul class="tbls">';
		foreach($table_names as $value){
			$body .= '<li class="tbl"><a href="?s=tbl&dbid='.$dbid.'&tblname='.$value["name"].'" target="body">'.$value["name"].'</a></li>';
		}
		$body .= '</li></ul>';
		echo $body;
		exit;

	//table構造取得
	}elseif(@$_GET["p"]=="tblstructure"){
		$tblname = $_GET["tblname"];
		$tbl_dbh = new PDO('sqlite:'.$config["db"][$_GET["dbid"]],'', '');
		$table_infoes = $tbl_dbh->prepare("PRAGMA table_info('".$tblname."');");
		$table_infoes->execute();
		$table_infoes = $table_infoes->fetchAll(PDO::FETCH_ASSOC);
		$body = "";
		$body .= <<<EOF
<table style="margin-top: 0.2em;margin-bottom: 1em;width: 570px;border-collapse: collapse;border: solid 1px #999;font-size: 100%;">
	<colgroup>
		<col span=6 width="150px" ></col>
	</colgroup>
	<tr style="border: solid 1px #999;">
EOF;
		foreach($table_infoes[0] as $table_info_c=>$table_info_v){
			$body .= '<th style="background: #E6E6E6;text-align: center;white-space: nowrap;color: #666;border: solid 1px #999;padding: 4px 6px;">';
			$body .= $table_info_c;
			$body .= '</th>';
		}
		$body .= '</tr>';
		foreach($table_infoes as $table_info){
			$body .= '<tr style="border: solid 1px #999;">';
			foreach($table_info as $table_info_i){
				$body .= '<td style="border: solid 1px #999;">';
				$body .= $table_info_i;
				$body .= '</td>';
			}
			$body .= '</tr>';
		}
		$body .= '</table>';

		echo $body;
		exit;

	//tableデータ取得
	}elseif(@$_GET["p"]=="tbldata"){
		$tblname = $_GET["tblname"];
		$tbl_dbh = new PDO('sqlite:'.$config["db"][$_GET["dbid"]],'', '');

		//件数取得
		$tbl_count = $tbl_dbh->prepare("SELECT count(*) as c FROM ".$tblname);
		$tbl_count->execute();
		$tbl_count = $tbl_count->fetchAll();
		$rows_count = $tbl_count[0]["c"];

		if($rows_count>0){
			//現在のページ設定
			if(isset($_GET["i"])){$p = $_GET["i"];
			}else{$p = 1;}

			//1ページに表示するリミット設定(オプション)
			if(isset($_GET["l"])){$limit = $_GET["l"];}
			if(empty($limit)){$limit = 5;
			}else{$limit = intval($limit);}

			//ソート関連
			if(isset($_GET["sort"])){$sort = " ORDER BY ".$_GET["sort"]." ".$_GET["jun"];
			}else{$sort = "";}

			//現在のページ
			$p = (ceil($rows_count / $limit) < $p)?ceil($rows_count / $limit):$p;
			$offset = ($p-1)*$limit;

			$table_infoes = $tbl_dbh->prepare("SELECT * FROM ".$tblname." {$sort} LIMIT {$offset} , {$limit} ");
			$table_infoes->execute();
			$table_infoes = $table_infoes->fetchAll(PDO::FETCH_ASSOC);
		}

		$body = "";
		$body .= getTableView($table_infoes,$limit);
		$body .= page_pager($p,$rows_count,$limit);

		echo $body;
		exit;


	}elseif(@$_GET["p"]=="sql"){
		$dbid = $_GET["dbid"];
		$body = <<<EOF
	<form action="#">
		<textarea name="sql" id="sql" rows="4" cols="40"></textarea><br />
		<input type="button" value="EXEC" onclick='exec("tbl","sql");'/>
	</form>
EOF;
		echo $body;
		exit;
	}elseif(@$_GET["p"]=="sqlexec"){

		$dbid = $_GET["dbid"];
		$sql = @$_POST["sql"];

		$body ="";
		$err_msg = "";
		$hidden_sql = "";
		$TableView = "";

	try {
		$tbl_dbh = new PDO('sqlite:'.$config["db"][$_GET["dbid"]],'', '');
		$tbl_dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

		if(preg_match('/^select/i',ltrim($sql))){
			$count_sql = preg_replace('/LIMIT *[0-9].*/i','',$sql);

			$count_sql = 'select count(*) as c from '.preg_replace('/^select.*from/i','',ltrim($count_sql));
			$table_infoes = $tbl_dbh->query($count_sql);
			$table_infoes = $table_infoes->fetchAll(PDO::FETCH_ASSOC);
			$rows_count = $table_infoes[0]["c"];

			if($rows_count>0){
				//現在のページ設定
				if(isset($_POST["i"])){$p = $_POST["i"];
				}else{$p = 1;}

				//1ページに表示するリミット設定(オプション)
				if(isset($_GET["l"])){$limit = $_GET["l"];}
				if(empty($limit)){$limit = 5;
				}else{$limit = intval($limit);}

				//現在のページ
				$p = (ceil($rows_count / $limit) < $p)?ceil($rows_count / $limit):$p;
				$offset = ($p-1)*$limit;

				$sql = preg_replace('/;$/',"",rtrim($sql));
				if(!preg_match('/LIMIT *[0-9]/i',$sql)){
					$sql = $sql." LIMIT {$offset} , {$limit} ";
				}

				$table_infoes = $tbl_dbh->query($sql);
				$table_infoes = $table_infoes->fetchAll(PDO::FETCH_ASSOC);

				$hidden_sql = preg_replace('/LIMIT *[0-9].*/i','',$sql);
				$hidden_sql = '<input type="hidden" name="hidden_sql" id="hidden_sql" value="'.$hidden_sql.'" />';
				$TableView = getTableView($table_infoes,$limit);
				$TableView .= exec_page_pager($p,$rows_count,$limit);
			}
		}else{
			$table_infoes = $tbl_dbh->exec($sql);
		}

		$tbl_dbh = null;
	} catch (PDOException $e) {
		$err_msg = $e->getMessage();
		$body .= "<div style='border:1px solid red;color:red;'>{$err_msg}</div>";
		$tbl_dbh = null;
	}

		$body .= <<<EOF
	<div style="border:1px solid gray;">{$sql}</div>
EOF;
		if(!empty($TableView)){
			$body .= $TableView.$hidden_sql;
		}else{
			$body .= <<<EOF
	<form action="#">
		<textarea name="sql" id="sql" rows="4" cols="40">{$sql}</textarea><br />
		<input type="button" value="EXEC" onclick='exec("tbl","sql");'/>
	</form>
EOF;
		}
		echo $body;
		exit;
	}


//tblsの場合
}else if(@$_GET["s"] == "tbls"){
	$dbid = $_GET["dbid"];
	if(empty($config["db"][$dbid])){echo "err!<br />データベースが見つかりません。";exit;}
	$db_path = dirname(__FILE__)."/".$config["db"][$dbid];
	$db_name = basename($db_path);
	$me = $_SERVER["SCRIPT_NAME"];
	$head = <<<EOF
<script type="text/javascript"><!--
window.onload = function (){
	var divObj = document.getElementById("tbllist");
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=tbllist&dbid={$dbid}");
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
}
// --></script>
EOF;

	$body = <<<EOF
	<h2>{$db_name}<h2>
	<div>{$db_path}</div>
	<hr/>
	<div id="tbllist"></div>
EOF;
	echo buildHtml_s($body,"tbls",$head);
	exit;



//tblの場合
}else if(@$_GET["s"] == "tbl"){
	$tblname = $_GET["tblname"];
	$dbid = $_GET["dbid"];
	$me = $_SERVER["SCRIPT_NAME"];
	$head = <<<EOF
<script type="text/javascript"><!--
window.onload = function (){
	view.tblstructure("tbl");
}

view = {};

view.tblstructure = function(div_id){
	var divObj = document.getElementById(div_id);
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=tblstructure&dbid={$dbid}&tblname={$tblname}");
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
	menu(1);
	return false;
}

view.tbldata = function(div_id,page){
	var divObj = document.getElementById(div_id);
	if(document.getElementById("viewlimit")){
		var viewlimit = document.getElementById("viewlimit").value;
	}else{
		var viewlimit = 5;
	}
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=tbldata&dbid={$dbid}&tblname={$tblname}&i="+page+"&l="+viewlimit);
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
	menu(2);
	return false;
}
view.sql = function(div_id,page){
	var divObj = document.getElementById(div_id);
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=sql&dbid={$dbid}&tblname={$tblname}");
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
	menu(3);
	return false;
}

exec = function(div_id,div_sql){
	var divObj = document.getElementById(div_id);
	var sql = document.getElementById(div_sql).value;
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=sqlexec&dbid={$dbid}","sql="+sql);
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
	menu(3);
	return false;
}

execpage = function(div_id,div_sql,page){
	var divObj = document.getElementById(div_id);
	var sql = document.getElementById(div_sql).value;
	var viewlimit = document.getElementById("viewlimit").value;
	var httpObj = new JKL.ParseXML.Text("${me}?s=html&p=sqlexec&dbid={$dbid}&l="+viewlimit,"sql="+sql+"&i="+page);
	var data = httpObj.parse();
	if(data.length>0){
		divObj.innerHTML = data;
	}
	menu(3);
	return false;
}

menu = function(menu_num){
	var menu1 = document.getElementById("menu1");
	var menu2 = document.getElementById("menu2");
	var menu3 = document.getElementById("menu3");

	switch(menu_num)
	{
	case 1:
		menu1.innerHTML = '構造';
		menu2.innerHTML = '<a href="" onclick=\'return view.tbldata("tbl",1);\'>データ</a>';
		menu3.innerHTML = '<a href="#" onclick=\'return view.sql("tbl");\'>SQL</a>';
		break;
	case 2:
		menu1.innerHTML = '<a href="#" onclick=\'return view.tblstructure("tbl");\'>構造</a>';
		menu2.innerHTML = 'データ';
		menu3.innerHTML = '<a href="#" onclick=\'return view.sql("tbl");\'>SQL</a>';
		break;
	case 3:
		menu1.innerHTML = '<a href="#" onclick=\'return view.tblstructure("tbl");\'>構造</a>';
		menu2.innerHTML = '<a href="" onclick=\'return view.tbldata("tbl",1);\'>データ</a>';
		menu3.innerHTML = '<a href="#" onclick=\'return view.sql("tbl");\'>SQL</a>';
		break;
	default:
		menu1.innerHTML = '<a href="#" onclick=\'return view.tblstructure("tbl");\'>構造</a>';
		menu2.innerHTML = '<a href="" onclick=\'return view.tbldata("tbl",1);\'>データ</a>';
		menu3.innerHTML = '<a href="#" onclick=\'return view.sql("tbl");\'>SQL</a>';
	}

}
// --></script>
EOF;

	$body = <<<EOF
	<h2>table info - ${tblname}</h2>
	<hr/>
	<span id="menu1"></span>|<span id="menu2"></span>|<span id="menu3"></span>
	<hr/>
	<div id="tbl"></div>
EOF;
	echo buildHtml_s($body,"tbl",$head);
	exit;
}


function getTableView($table_infoes,$viewlimit=5){
		if(empty($table_infoes)){
			return "";
		}
		$body = "";

		$body .= '表示件数：<select name="viewlimit" id="viewlimit">';
		if($viewlimit==5){
			$body .= '<option value="5" selected >5</option>';
		}else{
			$body .= '<option value="5">5</option>';
		}
		if($viewlimit==10){
			$body .= '<option value="10" selected >10</option>';
		}else{
			$body .= '<option value="10">10</option>';
		}
		if($viewlimit==15){
			$body .= '<option value="15" selected >15</option>';
		}else{
			$body .= '<option value="15">15</option>';
		}
		if($viewlimit==20){
			$body .= '<option value="20" selected >20</option>';
		}else{
			$body .= '<option value="20">20</option>';
		}
		$body .= '</select>';


		$body .= <<<EOF
<table style="margin-top: 0.2em;margin-bottom: 1em;width: 570px;border-collapse: collapse;border: solid 1px #999;font-size: 100%;">
	<colgroup>
		<col span=6 width="150px" ></col>
	</colgroup>
	<tr style="border: solid 1px #999;">
EOF;
		foreach($table_infoes[0] as $table_info_c=>$table_info_v){
			$body .= '<th style="background: #E6E6E6;text-align: center;white-space: nowrap;color: #666;border: solid 1px #999;padding: 4px 6px;">';
			$body .= $table_info_c;
			$body .= '</th>';
		}
		$body .= '</tr>';
		foreach($table_infoes as $table_info){
			$body .= '<tr style="border: solid 1px #999;">';
			foreach($table_info as $table_info_i){
				$body .= '<td style="border: solid 1px #999;">';
				$body .= $table_info_i;
				$body .= '</td>';
			}
			$body .= '</tr>';
		}
		$body .= '</table>';
	return $body;
}

function page_pager($current_num,$countRe,$per_page=6){
	// 現在のページ情報を取得
	$VIEW_PAGE_MENU_WIDTH = 2;
	$PREV_MARK = "&lt;";
	$NEXT_MARK = "&gt;";
	$startMore="";
	$endMore="";
	$startPage=1;
	$endPage=0;

	$now_page =intval($current_num);
	$now_page =(empty($now_page))?1:$now_page;
	$now_page =(ceil($countRe / $per_page) < $now_page)?ceil($countRe / $per_page):$now_page;

	if($now_page=="") $now_page=1;
	$maxPage=ceil($countRe / $per_page);
	if( ($maxPage == 1) or ($maxPage < $now_page) ) return false;
	if($now_page > 1){
		$startMore .= "<a href=\"#\" onclick='return view.tbldata(\"tbl\",".($now_page - 1).");'>".$PREV_MARK."</a>";
		if($now_page > $VIEW_PAGE_MENU_WIDTH + 1){
			$startPage = $now_page - $VIEW_PAGE_MENU_WIDTH;
			$startMore .= "<a href=\"#\" onclick='return view.tbldata(\"tbl\",".($now_page - 1).");'><span style=\"font-size:small;\">1</span></a><span style=\"font-size:xx-small;\">...</span>";
		}
	}else{
		$startPage = 1;
	}
	if($now_page < $maxPage){
		if($now_page + $VIEW_PAGE_MENU_WIDTH < $maxPage){
			$endPage = $now_page + $VIEW_PAGE_MENU_WIDTH;
			$endMore .= "<span style=\"font-size:xx-small;\">...</span><a href=\"#\" onclick='return view.tbldata(\"tbl\",".$maxPage.");'><span style=\"font-size:small;\">".$maxPage."</span></a>\n";
		}else{
			$endPage = $maxPage;
		}
		$endMore .= "<a href=\"#\" onclick='return view.tbldata(\"tbl\",".($now_page + 1).");'>".$NEXT_MARK."</a>\n";
	}else{
		$endPage = $maxPage;
	}
	$page_footer="";
	for($i = $startPage ; $i <= $endPage ; $i++){
		$page_footer.= " ".(($now_page==$i)?"<span style=\"font-size:small;\">$i</span>\n":"<span style=\"font-size:small;\"><a href=\"#\" onclick='return view.tbldata(\"tbl\",".$i.");'>$i</a></span>\n");
	}
	$page_footer = $startMore.$page_footer.$endMore;
	return $page_footer;
}

function exec_page_pager($current_num,$countRe,$per_page=6){
	// 現在のページ情報を取得
	$VIEW_PAGE_MENU_WIDTH = 2;
	$PREV_MARK = "&lt;";
	$NEXT_MARK = "&gt;";
	$startMore="";
	$endMore="";
	$startPage=1;
	$endPage=0;

	$now_page =intval($current_num);
	$now_page =(empty($now_page))?1:$now_page;
	$now_page =(ceil($countRe / $per_page) < $now_page)?ceil($countRe / $per_page):$now_page;

	if($now_page=="") $now_page=1;
	$maxPage=ceil($countRe / $per_page);
	if( ($maxPage == 1) or ($maxPage < $now_page) ) return false;
	if($now_page > 1){
		$startMore .= "<a href=\"#\" onclick='return execpage(\"tbl\",\"hidden_sql\",".($now_page - 1).");'>".$PREV_MARK."</a>";
		if($now_page > $VIEW_PAGE_MENU_WIDTH + 1){
			$startPage = $now_page - $VIEW_PAGE_MENU_WIDTH;
			$startMore .= "<a href=\"#\" onclick='return execpage(\"tbl\",\"hidden_sql\",".($now_page - 1).");'><span style=\"font-size:small;\">1</span></a><span style=\"font-size:xx-small;\">...</span>";
		}
	}else{
		$startPage = 1;
	}
	if($now_page < $maxPage){
		if($now_page + $VIEW_PAGE_MENU_WIDTH < $maxPage){
			$endPage = $now_page + $VIEW_PAGE_MENU_WIDTH;
			$endMore .= "<span style=\"font-size:xx-small;\">...</span><a href=\"#\" onclick='return execpage(\"tbl\",\"hidden_sql\",".$maxPage.");'><span style=\"font-size:small;\">".$maxPage."</span></a>\n";
		}else{
			$endPage = $maxPage;
		}
		$endMore .= "<a href=\"#\" onclick='return execpage(\"tbl\",\"hidden_sql\",".($now_page + 1).");'>".$NEXT_MARK."</a>\n";
	}else{
		$endPage = $maxPage;
	}
	$page_footer="";
	for($i = $startPage ; $i <= $endPage ; $i++){
		$page_footer.= " ".(($now_page==$i)?"<span style=\"font-size:small;\">$i</span>\n":"<span style=\"font-size:small;\"><a href=\"#\" onclick='return execpage(\"tbl\",\"hidden_sql\",".$i.");'>$i</a></span>\n");
	}
	$page_footer = $startMore.$page_footer.$endMore;
	return $page_footer;
}


function getdbdata($dbs){
	for($i=0;$i<count($dbs);$i++){
		$tbl_dbh = new PDO('sqlite:'.$dbs[$i],'', '');
		$table_names = $tbl_dbh->prepare("select name from sqlite_master where type='table' order by name");
		$table_names->execute();
		$table_names = $table_names->fetchAll(PDO::FETCH_ASSOC);
		$j=0;
		$result[$i]["db"] = basename($dbs[$i]);
		for($j=0;$j<count($table_names);$j++){
			$result[$i]["tables"][$j] = $table_names[$j];
		}
	}
	return $result;
}

function getLogoutP(){
	$me = $_SERVER["SCRIPT_NAME"];
	return <<<EOF
	<h2>ログアウト</h2>
	<p>Logout...</p>
	<p><a href="${me}">Top</a></p>
EOF;
}


function getericcss(){
  return <<<EOF
/*Eric Meyer Reset CSS*/
html, body, div, span, applet, object, iframe, table, caption,
tbody, tfoot, thead, tr, th, td, del, dfn, em, font, img, ins,
kbd, q, s, samp, small, strike, strong, sub, sup, tt, var,
h1, h2, h3, h4, h5, h6, p, blockquote, pre, a, abbr,
acronym, address, big, cite, code, dl, dt, dd, ol, ul, li,
fieldset, form, label, legend{
	vertical-align:baseline;
	font-family:inherit;
	font-weight:inherit;
	font-style:inherit;
	font-size:100%;
	outline:0;
	padding:0;
	margin:0;
	border:0;
}
:focus{
	outline:0;
}
body{
	background:white;
	line-height:1;
	color:black;
}
ol, ul{
	list-style:none;
}
table{
	border-collapse:separate;
	border-spacing:0;
}
caption, th, td{
	font-weight:normal;
	text-align:left;
}
blockquote:bfore, blockquote:after, q:before, q:after{
	content: "";
}
blockquote, q{
	quotes:"" "";
}
EOF;
}


function getcss(){
  return <<<EOF
/* OneSQLiteAdmin */
ul.dbs li.db {
	list-style:none;
	background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAsAAAALAQMAAACTYuVlAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAZQTFRFAAAA////pdmf3QAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIFYzLjM2aCbNIQAAACRJREFUCNdjOJDAsH8Bg4MDQ/0BBp8DDKEODCFgEsgGijQoAAC0HAp0htmWJwAAAABJRU5ErkJggg==) no-repeat;
	background-position: 2px 3px;
	padding-left:15px
}
.tbl-non{display:none;}
.tbl{
	list-style:none;
	background: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAOAQMAAAAc4Q7JAAAABlBMVEX///8AAABVwtN+AAAAE0lEQVQImWP4/58BiFoUoQg3GwBfJw/EGicjrwAAAABJRU5ErkJggg==) no-repeat;
	background-position: 0px 2px;
	padding-left:17px
}
EOF;
}

function getjs(){
	return <<<EOF
/* OneSQLiteAdminjs */
EOF;
}

function getjkl_parsexml_js(){
	return <<<EOF
// ================================================================
//  jkl-parsexml.js ---- JavaScript Kantan Library for Parsing XML
//  Copyright 2005-2007 Kawasaki Yusuke <u-suke@kawa.net>
//  http://www.kawa.net/works/js/jkl/parsexml.html
// ================================================================
//  v0.01  2005/05/18  first release
//  v0.02  2005/05/20  Opera 8.0beta may be abailable but somtimes crashed
//  v0.03  2005/05/20  overrideMimeType( "text/xml" );
//  v0.04  2005/05/21  class variables: REQUEST_TYPE, RESPONSE_TYPE
//  v0.05  2005/05/22  use Msxml2.DOMDocument.5.0 for GET method on IE6
//  v0.06  2005/05/22  CDATA_SECTION_NODE
//  v0.07  2005/05/23  use Microsoft.XMLDOM for GET method on IE6
//  v0.10  2005/10/11  new function: JKL.ParseXML.HTTP.responseText()
//  v0.11  2005/10/13  new sub class: JKL.ParseXML.Text, JSON and DOM.
//  v0.12  2005/10/14  new sub class: JKL.ParseXML.CSV and CSVmap.
//  v0.13  2005/10/28  bug fixed: TEXT_NODE regexp for white spaces
//  v0.14  2005/11/06  bug fixed: TEXT_NODE regexp at Safari
//  v0.15  2005/11/08  bug fixed: JKL.ParseXML.CSV.async() method
//  v0.16  2005/11/15  new sub class: LoadVars, and UTF-8 text on Safari
//  v0.18  2005/11/16  improve: UTF-8 text file on Safari
//  v0.19  2006/02/03  use XMLHTTPRequest instead of ActiveX on IE7,iCab
//  v0.20  2006/03/22  (skipped)
//  v0.21  2006/11/30  use ActiveX again on IE7
//  v0.22  2007/01/04  JKL.ParseXML.JSON.parseResponse() updated
// ================================================================

if ( typeof(JKL) == 'undefined' ) JKL = function() {};

// ================================================================
//  class: JKL.ParseXML 

JKL.ParseXML = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, false );
    return this;
};

// ================================================================
//  class variables

JKL.ParseXML.VERSION = "0.22";
JKL.ParseXML.MIME_TYPE_XML  = "text/xml";
JKL.ParseXML.MAP_NODETYPE = [
    "",
    "ELEMENT_NODE",                 // 1
    "ATTRIBUTE_NODE",               // 2
    "TEXT_NODE",                    // 3
    "CDATA_SECTION_NODE",           // 4
    "ENTITY_REFERENCE_NODE",        // 5
    "ENTITY_NODE",                  // 6
    "PROCESSING_INSTRUCTION_NODE",  // 7
    "COMMENT_NODE",                 // 8
    "DOCUMENT_NODE",                // 9
    "DOCUMENT_TYPE_NODE",           // 10
    "DOCUMENT_FRAGMENT_NODE",       // 11
    "NOTATION_NODE"                 // 12
];

// ================================================================
//  define callback function (ajax)

JKL.ParseXML.prototype.async = function ( func, args ) {
    this.callback_func = func;      // callback function
    this.callback_arg  = args;      // first argument
};

JKL.ParseXML.prototype.onerror = function ( func, args ) {
    this.onerror_func = func;       // callback function
};

// ================================================================
//  method: parse()
//  return: parsed object
//  Download a file from remote server and parse it.

JKL.ParseXML.prototype.parse = function () {
    if ( ! this.http ) return;

    // set onerror call back 
    if ( this.onerror_func ) {
        this.http.onerror( this.onerror_func );
    }

    if ( this.callback_func ) {                             // async mode
        var copy = this;
        var proc = function() {
            if ( ! copy.http ) return;
            var data = copy.parseResponse();
            copy.callback_func( data, copy.callback_arg );  // call back
        };
        this.http.async( proc );
    }

    this.http.load();

    if ( ! this.callback_func ) {                           // sync mode
        var data = this.parseResponse();
        return data;
    }
};

// ================================================================
//  every child/children into array
JKL.ParseXML.prototype.setOutputArrayAll = function () {
    this.setOutputArray( true );
}
//  a child into scalar, children into array
JKL.ParseXML.prototype.setOutputArrayAuto = function () {
    this.setOutputArray( null );
}
//  every child/children into scalar (first sibiling only)
JKL.ParseXML.prototype.setOutputArrayNever = function () {
    this.setOutputArray( false );
}
//  specified child/children into array, other child/children into scalar
JKL.ParseXML.prototype.setOutputArrayElements = function ( list ) {
    this.setOutputArray( list );
}
//  specify how to treate child/children into scalar/array
JKL.ParseXML.prototype.setOutputArray = function ( mode ) {
    if ( typeof(mode) == "string" ) {
        mode = [ mode ];                // string into array
    }
    if ( mode && typeof(mode) == "object" ) {
        if ( mode.length < 0 ) {
            mode = false;               // false when array == [] 
        } else {
            var hash = {};
            for( var i=0; i<mode.length; i++ ) {
                hash[mode[i]] = true;
            }
            mode = hash;                // array into hashed array
            if ( mode["*"] ) {
                mode = true;            // true when includes "*"
            }
        } 
    } 
    this.usearray = mode;
}

// ================================================================
//  method: parseResponse()

JKL.ParseXML.prototype.parseResponse = function () {
    var root = this.http.documentElement();
    var data = this.parseDocument( root );
    return data;
}

// ================================================================
//  convert from DOM root node to JavaScript Object 
//  method: parseElement( rootElement )

JKL.ParseXML.prototype.parseDocument = function ( root ) {
    // debug.print( "parseDocument: "+root );
    if ( ! root ) return;

    var ret = this.parseElement( root );            // parse root node
    // debug.print( "parsed: "+ret );

    if ( this.usearray == true ) {                  // always into array
        ret = [ ret ];
    } else if ( this.usearray == false ) {          // always into scalar
        //
    } else if ( this.usearray == null ) {           // automatic
        //
    } else if ( this.usearray[root.nodeName] ) {    // specified tag
        ret = [ ret ];
    }

    var json = {};
    json[root.nodeName] = ret;                      // root nodeName
    return json;
};

// ================================================================
//  convert from DOM Element to JavaScript Object 
//  method: parseElement( element )

JKL.ParseXML.prototype.parseElement = function ( elem ) {
    // debug.print( "nodeType: "+JKL.ParseXML.MAP_NODETYPE[elem.nodeType]+" <"+elem.nodeName+">" );

    //  COMMENT_NODE

    if ( elem.nodeType == 7 ) {
        return;
    }

    //  TEXT_NODE CDATA_SECTION_NODE

    if ( elem.nodeType == 3 || elem.nodeType == 4 ) {
        // var bool = elem.nodeValue.match( /[^\\u0000-\\u0020]/ );
        var bool = elem.nodeValue.match( /[^\\x00-\\x20]/ ); // for Safari
        if ( bool == null ) return;     // ignore white spaces
        // debug.print( "TEXT_NODE: "+elem.nodeValue.length+ " "+bool );
        return elem.nodeValue;
    }

    var retval;
    var cnt = {};

    //  parse attributes

    if ( elem.attributes && elem.attributes.length ) {
        retval = {};
        for ( var i=0; i<elem.attributes.length; i++ ) {
            var key = elem.attributes[i].nodeName;
            if ( typeof(key) != "string" ) continue;
            var val = elem.attributes[i].nodeValue;
            if ( ! val ) continue;
            if ( typeof(cnt[key]) == "undefined" ) cnt[key] = 0;
            cnt[key] ++;
            this.addNode( retval, key, cnt[key], val );
        }
    }

    //  parse child nodes (recursive)

    if ( elem.childNodes && elem.childNodes.length ) {
        var textonly = true;
        if ( retval ) textonly = false;        // some attributes exists
        for ( var i=0; i<elem.childNodes.length && textonly; i++ ) {
            var ntype = elem.childNodes[i].nodeType;
            if ( ntype == 3 || ntype == 4 ) continue;
            textonly = false;
        }
        if ( textonly ) {
            if ( ! retval ) retval = "";
            for ( var i=0; i<elem.childNodes.length; i++ ) {
                retval += elem.childNodes[i].nodeValue;
            }
        } else {
            if ( ! retval ) retval = {};
            for ( var i=0; i<elem.childNodes.length; i++ ) {
                var key = elem.childNodes[i].nodeName;
                if ( typeof(key) != "string" ) continue;
                var val = this.parseElement( elem.childNodes[i] );
                if ( ! val ) continue;
                if ( typeof(cnt[key]) == "undefined" ) cnt[key] = 0;
                cnt[key] ++;
                this.addNode( retval, key, cnt[key], val );
            }
        }
    }
    return retval;
};

// ================================================================
//  method: addNode( hash, key, count, value )

JKL.ParseXML.prototype.addNode = function ( hash, key, cnts, val ) {
    if ( this.usearray == true ) {              // into array
        if ( cnts == 1 ) hash[key] = [];
        hash[key][hash[key].length] = val;      // push
    } else if ( this.usearray == false ) {      // into scalar
        if ( cnts == 1 ) hash[key] = val;       // only 1st sibling
    } else if ( this.usearray == null ) {
        if ( cnts == 1 ) {                      // 1st sibling
            hash[key] = val;
        } else if ( cnts == 2 ) {               // 2nd sibling
            hash[key] = [ hash[key], val ];
        } else {                                // 3rd sibling and more
            hash[key][hash[key].length] = val;
        }
    } else if ( this.usearray[key] ) {
        if ( cnts == 1 ) hash[key] = [];
        hash[key][hash[key].length] = val;      // push
    } else {
        if ( cnts == 1 ) hash[key] = val;       // only 1st sibling
    }
};

// ================================================================
//  class: JKL.ParseXML.Text 

JKL.ParseXML.Text = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML.Text( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, true );
    return this;
};

JKL.ParseXML.Text.prototype.parse = JKL.ParseXML.prototype.parse;
JKL.ParseXML.Text.prototype.async = JKL.ParseXML.prototype.async;
JKL.ParseXML.Text.prototype.onerror = JKL.ParseXML.prototype.onerror;

JKL.ParseXML.Text.prototype.parseResponse = function () {
    var data = this.http.responseText();
    return data;
}

// ================================================================
//  class: JKL.ParseXML.JSON

JKL.ParseXML.JSON = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML.JSON( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, true );
    return this;
};

JKL.ParseXML.JSON.prototype.parse = JKL.ParseXML.prototype.parse;
JKL.ParseXML.JSON.prototype.async = JKL.ParseXML.prototype.async;
JKL.ParseXML.JSON.prototype.onerror = JKL.ParseXML.prototype.onerror;

JKL.ParseXML.JSON.prototype.parseResponse = function () {
    var text = this.http.responseText();
    // http://www.antimon2.atnifty.com/2007/01/jklparsexmljson.html
    if ( typeof(text) == 'undefined' ) return;
    if ( ! text.length ) return;
    var data = eval( "("+text+")" );
    return data;
}

// ================================================================
//  class: JKL.ParseXML.DOM

JKL.ParseXML.DOM = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML.DOM( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, false );
    return this;
};

JKL.ParseXML.DOM.prototype.parse = JKL.ParseXML.prototype.parse;
JKL.ParseXML.DOM.prototype.async = JKL.ParseXML.prototype.async;
JKL.ParseXML.DOM.prototype.onerror = JKL.ParseXML.prototype.onerror;

JKL.ParseXML.DOM.prototype.parseResponse = function () {
    var data = this.http.documentElement();
    return data;
}

// ================================================================
//  class: JKL.ParseXML.CSV

JKL.ParseXML.CSV = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML.CSV( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, true );
    return this;
};

JKL.ParseXML.CSV.prototype.parse = JKL.ParseXML.prototype.parse;
JKL.ParseXML.CSV.prototype.async = JKL.ParseXML.prototype.async;
JKL.ParseXML.CSV.prototype.onerror = JKL.ParseXML.prototype.onerror;

JKL.ParseXML.CSV.prototype.parseResponse = function () {
    var text = this.http.responseText();
    var data = this.parseCSV( text );
    return data;
}

JKL.ParseXML.CSV.prototype.parseCSV = function ( text ) {
    text = text.replace( /\\r\\n?/g, "\\n" );              // new line character
    var pos = 0;
    var len = text.length;
    var table = [];
    while( pos<len ) {
        var line = [];
        while( pos<len ) {
            if ( text.charAt(pos) == '"' ) {            // "..." quoted column
                var nextquote = text.indexOf( '"', pos+1 );
                while ( nextquote<len && nextquote > -1 ) {
                    if ( text.charAt(nextquote+1) != '"' ) {
                        break;                          // end of column
                    }
                    nextquote = text.indexOf( '"', nextquote+2 );
                }
                if ( nextquote < 0 ) {
                    // unclosed quote
                } else if ( text.charAt(nextquote+1) == "," ) { // end of column
                    var quoted = text.substr( pos+1, nextquote-pos-1 );
                    quoted = quoted.replace(/""/g,'"');
                    line[line.length] = quoted;
                    pos = nextquote+2;
                    continue;
                } else if ( text.charAt(nextquote+1) == "\\n" || // end of line
                            len==nextquote+1 ) {                // end of file
                    var quoted = text.substr( pos+1, nextquote-pos-1 );
                    quoted = quoted.replace(/""/g,'"');
                    line[line.length] = quoted;
                    pos = nextquote+2;
                    break;
                } else {
                    // invalid column
                }
            }
            var nextcomma = text.indexOf( ",", pos );
            var nextnline = text.indexOf( "\\n", pos );
            if ( nextnline < 0 ) nextnline = len;
            if ( nextcomma > -1 && nextcomma < nextnline ) {
                line[line.length] = text.substr( pos, nextcomma-pos );
                pos = nextcomma+1;
            } else {                                    // end of line
                line[line.length] = text.substr( pos, nextnline-pos );
                pos = nextnline+1;
                break;
            }
        }
        if ( line.length >= 0 ) {
            table[table.length] = line;                 // push line
        }
    }
    if ( table.length < 0 ) return;                     // null data
    return table;
};

// ================================================================
//  class: JKL.ParseXML.CSVmap

JKL.ParseXML.CSVmap = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML.CSVmap( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, true );
    return this;
};

JKL.ParseXML.CSVmap.prototype.parse = JKL.ParseXML.prototype.parse;
JKL.ParseXML.CSVmap.prototype.async = JKL.ParseXML.prototype.async;
JKL.ParseXML.CSVmap.prototype.onerror = JKL.ParseXML.prototype.onerror;
JKL.ParseXML.CSVmap.prototype.parseCSV = JKL.ParseXML.CSV.prototype.parseCSV;

JKL.ParseXML.CSVmap.prototype.parseResponse = function () {
    var text = this.http.responseText();
    var source = this.parseCSV( text );
    if ( ! source ) return;
    if ( source.length < 0 ) return;

    var title = source.shift();                 // first line as title
    var data = [];
    for( var i=0; i<source.length; i++ ) {
        var hash = {};
        for( var j=0; j<title.length && j<source[i].length; j++ ) {
            hash[title[j]] = source[i][j];      // array to map
        }
        data[data.length] = hash;               // push line
    }
    return data;
}

// ================================================================
//  class: JKL.ParseXML.LoadVars

JKL.ParseXML.LoadVars = function ( url, query, method ) {
    // debug.print( "new JKL.ParseXML.LoadVars( '"+url+"', '"+query+"', '"+method+"' );" );
    this.http = new JKL.ParseXML.HTTP( url, query, method, true );
    return this;
};

JKL.ParseXML.LoadVars.prototype.parse = JKL.ParseXML.prototype.parse;
JKL.ParseXML.LoadVars.prototype.async = JKL.ParseXML.prototype.async;
JKL.ParseXML.LoadVars.prototype.onerror = JKL.ParseXML.prototype.onerror;

JKL.ParseXML.LoadVars.prototype.parseResponse = function () {
    var text = this.http.responseText();
    text = text.replace( /\\r\\n?/g, "\\n" );              // new line character
    var hash = {};
    var list = text.split( "&" );
    for( var i=0; i<list.length; i++ ) {
        var eq = list[i].indexOf( "=" );
        if ( eq > -1 ) {
            var key = decodeURIComponent(list[i].substr(0,eq).replace("+","%20"));
            var val = decodeURIComponent(list[i].substr(eq+1).replace("+","%20"));
            hash[key] = val;
        } else {
            hash[list[i]] = "";
        }
    }
    return hash;
};

// ================================================================
//  class: JKL.ParseXML.HTTP
//  constructer: new JKL.ParseXML.HTTP()

JKL.ParseXML.HTTP = function( url, query, method, textmode ) {
    // debug.print( "new JKL.ParseXML.HTTP( '"+url+"', '"+query+"', '"+method+"', '"+textmode+"' );" );
    this.url = url;
    if ( typeof(query) == "string" ) {
        this.query = query;
    } else {
        this.query = "";
    }
    if ( method ) {
        this.method = method;
    } else if ( typeof(query) == "string" ) {
        this.method = "POST";
    } else {
        this.method = "GET";
    }
    this.textmode = textmode ? true : false;
    this.req = null;
    this.xmldom_flag = false;
    this.onerror_func  = null;
    this.callback_func = null;
    this.already_done = null;
    return this;
};

// ================================================================
//  class variables

JKL.ParseXML.HTTP.REQUEST_TYPE  = "application/x-www-form-urlencoded";
JKL.ParseXML.HTTP.ACTIVEX_XMLDOM  = "Microsoft.XMLDOM";  // Msxml2.DOMDocument.5.0
JKL.ParseXML.HTTP.ACTIVEX_XMLHTTP = "Microsoft.XMLHTTP"; // Msxml2.XMLHTTP.3.0
JKL.ParseXML.HTTP.EPOCH_TIMESTAMP = "Thu, 01 Jun 1970 00:00:00 GMT"

// ================================================================

JKL.ParseXML.HTTP.prototype.onerror = JKL.ParseXML.prototype.onerror;
JKL.ParseXML.HTTP.prototype.async = function( func ) {
    this.async_func = func;
}

// ================================================================
//  [IE+IXMLDOMElement]
//      XML     text/xml            OK
//      XML     application/rdf+xml OK
//      TEXT    text/plain          NG
//      TEXT    others              NG
//  [IE+IXMLHttpRequest]
//      XML     text/xml            OK
//      XML     application/rdf+xml NG
//      TEXT    text/plain          OK
//      TEXT    others              OK
//  [Firefox+XMLHttpRequest]
//      XML     text/xml            OK
//      XML     application/rdf+xml OK (overrideMimeType)
//      TEXT    text/plain          OK
//      TEXT    others              OK (overrideMimeType)
//  [Opera+XMLHttpRequest]
//      XML     text/xml            OK
//      XML     application/rdf+xml OK
//      TEXT    text/plain          OK
//      TEXT    others              OK
// ================================================================

JKL.ParseXML.HTTP.prototype.load = function() {
    // create XMLHttpRequest object
    if ( window.ActiveXObject ) {                           // IE5.5,6,7
        var activex = JKL.ParseXML.HTTP.ACTIVEX_XMLHTTP;    // IXMLHttpRequest
        if ( this.method == "GET" && ! this.textmode ) {
            // use IXMLDOMElement to accept any mime types
            // because overrideMimeType() is not available on IE6
            activex = JKL.ParseXML.HTTP.ACTIVEX_XMLDOM;     // IXMLDOMElement
        }
        // debug.print( "new ActiveXObject( '"+activex+"' )" );
        this.req = new ActiveXObject( activex );
    } else if ( window.XMLHttpRequest ) {                   // Firefox, Opera, iCab
        // debug.print( "new XMLHttpRequest()" );
        this.req = new XMLHttpRequest();
    }

    // async mode when call back function is specified
    var async_flag = this.async_func ? true : false;
    // debug.print( "async: "+ async_flag );

    // open for XMLHTTPRequest (not for IXMLDOMElement)
    if ( typeof(this.req.send) != "undefined" ) {
        // debug.print( "open( '"+this.method+"', '"+this.url+"', "+async_flag+" );" );
        this.req.open( this.method, this.url, async_flag );
    }

//  // If-Modified-Since: Thu, 01 Jun 1970 00:00:00 GMT
//  if ( typeof(this.req.setRequestHeader) != "undefined" ) {
//      // debug.print( "If-Modified-Since"+JKL.ParseXML.HTTP.EPOCH_TIMESTAMP );
//      this.req.setRequestHeader( "If-Modified-Since", JKL.ParseXML.HTTP.EPOCH_TIMESTAMP );
//  }

    // Content-Type: application/x-www-form-urlencoded (request header)
    // Some server does not accept without request content-type.
    if ( typeof(this.req.setRequestHeader) != "undefined" ) {
        // debug.print( "Content-Type: "+JKL.ParseXML.HTTP.REQUEST_TYPE+" (request)" );
        this.req.setRequestHeader( "Content-Type", JKL.ParseXML.HTTP.REQUEST_TYPE );
    }

    // Content-Type: text/xml (response header)
    // FireFox does not accept other mime types like application/rdf+xml etc.
    if ( typeof(this.req.overrideMimeType) != "undefined" && ! this.textmode ) {
        // debug.print( "Content-Type: "+JKL.ParseXML.MIME_TYPE_XML+" (response)" );
        this.req.overrideMimeType( JKL.ParseXML.MIME_TYPE_XML );
    }

    // set call back handler when async mode
    if ( async_flag ) {
        var copy = this;
        copy.already_done = false;                  // not parsed yet
        var check_func = function () {
            if ( copy.req.readyState != 4 ) return;
            // debug.print( "readyState(async): "+copy.req.readyState );
            var succeed = copy.checkResponse();
            // debug.print( "checkResponse(async): "+succeed );
            if ( ! succeed ) return;                // failed
            if ( copy.already_done ) return;        // parse only once
            copy.already_done = true;               // already parsed
            copy.async_func();                      // call back async
        };
        this.req.onreadystatechange = check_func;
        // for document.implementation.createDocument
        // this.req.onload = check_func;
    }

    // send the request and query string
    if ( typeof(this.req.send) != "undefined" ) {
        // debug.print( "XMLHTTPRequest: send( '"+this.query+"' );" );
        this.req.send( this.query );                        // XMLHTTPRequest
    } else if ( typeof(this.req.load) != "undefined" ) {
        // debug.print( "IXMLDOMElement: load( '"+this.url+"' );" );
        this.req.async = async_flag;
        this.req.load( this.url );                          // IXMLDOMElement
    }

    // just return when async mode
    if ( async_flag ) return;

    var succeed = this.checkResponse();
    // debug.print( "checkResponse(sync): "+succeed );
}

// ================================================================
//  method: checkResponse()

JKL.ParseXML.HTTP.prototype.checkResponse = function() {
    // parseError on IXMLDOMElement
    if ( this.req.parseError && this.req.parseError.errorCode != 0 ) {
        // debug.print( "parseError: "+this.req.parseError.reason );
        if ( this.onerror_func ) this.onerror_func( this.req.parseError.reason );
        return false;                       // failed
    }

    // HTTP response code
    if ( this.req.status-0 > 0 &&
         this.req.status != 200 &&          // OK
         this.req.status != 206 &&          // Partial Content
         this.req.status != 304 ) {         // Not Modified
        // debug.print( "status: "+this.req.status );
        if ( this.onerror_func ) this.onerror_func( this.req.status );
        return false;                       // failed
    }

    return true;                            // succeed
}

// ================================================================
//  method: documentElement()
//  return: XML DOM in response body

JKL.ParseXML.HTTP.prototype.documentElement = function() {
    // debug.print( "documentElement: "+this.req );
    if ( ! this.req ) return;
    if ( this.req.responseXML ) {
        return this.req.responseXML.documentElement;    // XMLHTTPRequest
    } else {
        return this.req.documentElement;                // IXMLDOMDocument
    }
}

// ================================================================
//  method: responseText()
//  return: text string in response body

JKL.ParseXML.HTTP.prototype.responseText = function() {
    // debug.print( "responseText: "+this.req );
    if ( ! this.req ) return;

    //  Safari and Konqueror cannot understand the encoding of text files.
    if ( navigator.appVersion.match( "KHTML" ) ) {
        var esc = escape( this.req.responseText );
//        debug.print( "escape: "+esc );
        if ( ! esc.match("%u") && esc.match("%") ) {
            return decodeURIComponent(esc);
        }
    }

    return this.req.responseText;
}

// ================================================================
//  http://msdn.microsoft.com/library/en-us/xmlsdk/html/d051f7c5-e882-42e8-a5b6-d1ce67af275c.asp
// ================================================================
EOF;
}

function getLoginP(){
	$me = $_SERVER["SCRIPT_NAME"];
	return <<<EOF
<div class="container"> 
<div class="header"> 
	<h1> 
		<a href="${me}" class="title">OneSQLiteAdmin</a>
	</h1> 
</div> 
 
	<h2>ログイン</h2> 
	<form method="post" action="${me}"> 
		<p> 
			<label for="onedbadmin_username">User:</label> 
			<input type="text" name="onedbadmin_username" id="onedbadmin_username" class="textinput" /> 
		</p> 
		<p> 
			<label for="onedbadmin_password">Password:</label> 
			<input type="password" name="onedbadmin_password" id="onedbadmin_password" class="textinput" /> 
		</p> 
		<p><input type="submit" class="button" value="Enter" /></p> 
	</form> 
</div> 
EOF;

}


/*
 *フレームの外側用
 */
function buildHtml($body , $title="", $head=""){
	if(empty($title)){
		$title="OneSQLiteAdmin";
	}else{
		$title="OneSQLiteAdmin - ".$title;
	}
	$result = <<<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="robots" content="noindex">
<link rel="shortcut icon" href="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAsAAAALAQMAAACTYuVlAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAZQTFRFAAAA////pdmf3QAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIFYzLjM2aCbNIQAAACRJREFUCNdjOJDAsH8Bg4MDQ/0BBp8DDKEODCFgEsgGijQoAAC0HAp0htmWJwAAAABJRU5ErkJggg==" />
<title>${title}</title>
<link rel="stylesheet" type="text/css" href="?s=resetcss" media="all">
<link rel="stylesheet" type="text/css" href="?s=css" media="all">
<script src="?s=jkl-parsexmlJs" type="text/javascript"></script>
<script src="?s=js" type="text/javascript"></script>
{$head}</head>
<body>
EOF;
	$result .= $body;
	$result .= "</body></html>";
	return $result;
}

/*
 *フレームの内側用
 */
function buildHtml_s($body , $title="", $head=""){
	if(empty($title)){
		$title="OneSQLiteAdmin";
	}else{
		$title="OneSQLiteAdmin - ".$title;
	}
	$result = <<<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="robots" content="noindex">
<title>${title}</title>
<link rel="stylesheet" type="text/css" href="?s=resetcss" media="all">
<link rel="stylesheet" type="text/css" href="?s=css" media="all">
<script src="?s=jkl-parsexmlJs" type="text/javascript"></script>
<script src="?s=js" type="text/javascript"></script>
{$head}</head>
<body>
EOF;
	$result .= $body;
	$result .= "</body></html>";
	return $result;
}

